	GET	registers.s
	GET	swis.s

	IMPORT	|__draw_localx|

	AREA	|____font_find|, CODE, READONLY
	EXPORT	font_find
font_find

	STMFD	r13!,{r4,r5,lr}
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	MOV	r4,#0
	MOV	r5,#0
	SWI	XFont_FindFont
	MOVVS	r0,#0
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____font_lose|, CODE, READONLY
	EXPORT	font_lose
font_lose

	SWI	XFont_LoseFont
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____font_paint|, CODE, READONLY
	EXPORT	font_paint
font_paint

	STMFD	r13!,{r4-r6,lr}
	LDR	r5,=|__draw_localx|
	LDMIA	r5,{r5,r6}
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	TST	r2,#16
	ADDNE	r4,r4,r6
	ADDNE	r3,r3,r5
	SWI	XFont_Paint
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____font_converttoos|, CODE, READONLY
	EXPORT	font_converttoos
font_converttoos

	MOV	r12,r2
	MOV	r2,r1
	MOV	r1,r0
	SWI	XFont_ConverttoOS
	TEQ	r12,#0
	STRNE	r1,[r12]
	TEQ	r3,#0
	STRNE	r2,[r3]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____font_converttopoints|, CODE, READONLY
	EXPORT	font_converttopoints
font_converttopoints

	MOV	r12,r2
	MOV	r2,r1
	MOV	r1,r0
	SWI	XFont_Converttopoints
	TEQ	r12,#0
	STRNE	r1,[r12]
	TEQ	r3,#0
	STRNE	r2,[r3]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____font_setfont|, CODE, READONLY
	EXPORT	font_setfont
font_setfont

	SWI	XFont_SetFont
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____font_currentfont|, CODE, READONLY
	EXPORT	font_currentfont
font_currentfont

	SWI	XFont_CurrentFont
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____font_setfontcolours|, CODE, READONLY
	EXPORT	font_setfontcolours
font_setfontcolours

	SWI	XFont_SetFontColours
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____font_listfonts|, CODE, READONLY
	EXPORT	font_listfonts
font_listfonts

; r0 is ^ buffer
; r1 is counter
; r2 is size of buffer
; r3 is ^ font name
;!r13 is size of font name
; returns r0 as next item (-1 means last, -2 means error occurred)
	MOV	r12,r13
	STMFD	r13!,{r4,r5,lr}
	LDR	r5,[r12]
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	SWI	XFont_ListFonts
	MOVVC	r0,r2
	MOVVS	r0,#-2
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____font_charwidth|, CODE, READONLY
	EXPORT	font_charwidth
font_charwidth

; r0 is font handle
; r1 is ASCII code
; r2 is flag (0 means millipoints, nz means OS coordinates)

	STMFD	r13!,{r4,lr}
	MOVS	r2,r2
	MOVNE	r2,#16
	SWI	XFont_CharBBox
	MOVVS	r0,#-1
	SUBVC	r0,r3,r1
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	font_stringcut, CODE, READONLY
	EXPORT	font_stringwidth
; r0 is ^ string
; r1 is maximum x offset (in OS units)
; r2 is length of string

	STMFD	r13!,{r4,r5,lr}
	MOV	r4,r0
	MOV	r5,r2
	MOV	r2,#1024
	SWI	XFont_Converttopoints
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r4
	MOV	r4,#' '
	SWI	XFont_StringWidth
	MOVVS	r0,#-1
	MOVVC	r0,r5
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____font_stringwidth|, CODE, READONLY
	EXPORT	font_stringwidth
font_stringwidth

; r0 is ^ string
; r1 is maximum x offset (in OS units)
; r2 is length of string
; returns OS units of width of string

	STMFD	r13!,{r4,r5,lr}
	MOV	r4,r0
	MOV	r5,r2
	MOV	r2,#1024
	SWI	XFont_Converttopoints
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r4
	MOV	r4,#-1
	SWI	XFont_StringWidth
	MOVVS	r0,#-1
 [ arm32
	LDMVSFD	r13!,{r4,r5,pc}
 |
	LDMVSFD	r13!,{r4,r5,pc}^
 ]
	SWI	Font_ConverttoOS
	MOV	r0,r2
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	END
