	GET	swis.s
	GET	registers.s

	AREA	|____freeway_write|, CODE, READONLY
	EXPORT	freeway_write
freeway_write

; r0 is flags
; r1 is type
; r2 is ^ object name
; r3 is length of object descriptor
; r12!0 is ^ object descriptor
; r12!4 is authentication
; returns r0=0 for failure, 1 for success
	MOV	r12,r13
	STMFD	r13!,{r4,r5,lr}
	LDMIA	r12,{r4,r5}
	SWI	&67a80
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____freeway_read|, CODE, READONLY
	EXPORT	freeway_read
freeway_read

; r0 is flags
; r1 is type
; r2 is ^ object name
; r3 is length of object descriptor
; r12!0 is ^ object descriptor
; r12!4 is authentication
; returns r0 as descriptor length, or -1 for failure
	MOV	r12,r13
	STMFD	r13!,{r4,r5,lr}
	LDMIA	r12,{r4,r5}
	SWI	&67a80
	MOVVS	r0,#-1
	MOVVC	r0,r3
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____freeway_register|, CODE, READONLY
	EXPORT	freeway_register
freeway_register

; r0 is flags
; r1 is type
; r2 is ^ object name
; r3 is length of object descriptor
; returns r0=0 for failure, 1 for success
	SWI	&67a80
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	END
